c=======main function of the program================================
      program main
      implicit none
      double precision xsec, error, xn, en, xcoe(42), ecoe(42)
      double precision xcoep(42), ecoep(42)
      integer n1, n2, n3, nn, i, j, ttm, itt, jj
      character*100 tee2, tee3, tee4, time1, time2, zz
      include "var.inc"

      call getarg(1, job)
      tee2=trim(adjustl(adjustr(job)))//"_fitCSresults.dat"
      tee3=trim(adjustl(adjustr(job)))//"_fitLLresults.dat"
      tee4=trim(adjustl(adjustr(job)))//"_fitALresults.dat"
      call readvar          
      ttm=time8()
      call ctime(ttm, time1)

      nn=0

      if(mode.eq.'fitcs') then
      open(unit=111, file=tee2, status='unknown')
      elseif(mode.eq.'fitll') then
      open(unit=111, file=tee3, status='unknown')
      elseif(mode.eq.'fital') then
      open(unit=111, file=tee4, status='unknown')
      else
      print *, "currently only run for mode= fitll/fitcs/fital!"
      stop
      endif

c===============start of writing header==============================

      write(*, *) "************************************************"
      write(*, *) "*                   CIJET                      *"
      write(*, *) "*        (J. Gao, C. S. Li, C.-P. Yuan)        *"
      write(*, *) "*            version 1.1; June 2014            *"
      write(*, *) "*                                              *"
      write(*, *) "*                                              *"
      write(*, *) "*                references:                   *"
      write(*, *) "*        arXiv:1204.4773, 1101.4611            *"
      write(*, *) "************************************************"

      write(*, *) ">>"
      write(*, '(A17,A5,I2,A8,F7.1,A4,A8,I4)') "processes input:","LHC=",
     - ppcollider, "sqrtS=",sqrtS, "GeV", "pseed=",pseed
      write(*, '(A17,2X,A22,A17,I3)') "PDF sets used:", pdfname,
     - "PDF member used:", pdfmember    
      if(scalescheme.eq.0) then
      if(ang.ne.4) then
      write(*, '(A11,A8,I3,A15,A13,A16)') "loop=0/1",
     - "ang=",ang, "mur(muf)=1.0", "(0.5/1.0/2.0)", "*(pt1+pt2)/2"
      else
      write(*, '(A11,A8,I3,A15,A13,A16)') "loop=0/1",
     - "ang=",ang, "mur(muf)=1.0", "(0.5/1.0/2.0)", "*pt_ind_jet"
      endif
      else
      if(ang.ne.4) then
      write(*, '(A11,A8,I3,A15,A13,A16)') "loop=0/1",
     - "ang=",ang, "mur(muf)=1.0", "(0.5/1.0/2.0)", "*pt1*exp(0.3ys)"
      else
      write(*, '(A11,A8,I3,A15,A13,A16)') "loop=0/1",
     - "ang=",ang, "mur(muf)=1.0", "(0.5/1.0/2.0)", "*pt_max_rbin"
      endif
      endif
      write (*,'(A35)') "fitting for the xsec coefficient"
      if(ang.eq.1) then
      write (*,'(A43)') "second observable in bin is chi in dijet" 
      elseif(ang.eq.2) then
      write (*,'(A43)') "second observable in bin is  ys in dijet" 
      elseif(ang.eq.3) then
      write (*,'(A44)') "second observable in bin is ymax in dijet" 
      elseif(ang.eq.4) then
      write (*,'(A46)') "second observable in bin is |y| in inc. jet" 
      endif

      write(*, *) ">>"
      write(*, '(A18,A10,I2,A10,I2)') "kinematics input:","Jscheme=",
     - jetscheme, "Rscheme=", recscheme    
      write(*, '(A18,F4.1,A6,F4.1)') "jet cone size =", Rcone, 
     -   "Rsep=", Rsep
      write(*, '(A17,A8,F4.2,A4,F6.2,A4)') "jet acceptance", "|y|<", 
     - ycut, "pt>", ptcut, "GeV"
      write(*, '(A8,F6.2,A12,F6.2)') "ptj1>", ptadd1, "ptj2>", ptadd2
      write(*, '(A12,F6.2,A10,F4.2)') "|yboost|<", yb, "ystar<", ys
      write(*, *) ">>"
      write (*,'(A27)') "waiting for the .........."
     
      write(111, *) "************************************************"
      write(111, *) "*                   CIJET                      *"
      write(111, *) "*        (J. Gao, C. S. Li, C.-P. Yuan)        *"
      write(111, *) "*            version 1.1; June 2014            *"
      write(111, *) "*                                              *"
      write(111, *) "*                                              *"
      write(111, *) "*                references:                   *"
      write(111, *) "*        arXiv:1204.4773, 1101.4611            *"
      write(111, *) "************************************************"

      write(111, *) ">>"
      write(111,'(A17,A5,I2,A8,F7.1,A4,A8,I4)') "processes input:",
     - "LHC=", ppcollider, "sqrtS=",sqrtS, "GeV", "pseed=",pseed
      write(111, '(A17,2X,A22,A17,I3)') "PDF sets used:", pdfname,
     - "PDF member used:", pdfmember    
      if(scalescheme.eq.0) then
      if(ang.ne.4) then
      write(111, '(A11,A8,I3,A15,A13,A16)') "loop=0/1",
     - "ang=",ang, "mur(muf)=1.0", "(0.5/1.0/2.0)", "*(pt1+pt2)/2"
      else
      write(111, '(A11,A8,I3,A15,A13,A16)') "loop=0/1",
     - "ang=",ang, "mur(muf)=1.0", "(0.5/1.0/2.0)", "*pt_ind_jet"
      endif
      else
      if(ang.ne.4) then
      write(111, '(A11,A8,I3,A15,A13,A16)') "loop=0/1",
     - "ang=",ang, "mur(muf)=1.0", "(0.5/1.0/2.0)", "*pt1*exp(0.3ys)"
      else
      write(111, '(A11,A8,I3,A15,A13,A16)') "loop=0/1",
     - "ang=",ang, "mur(muf)=1.0", "(0.5/1.0/2.0)", "*pt_max_rbin"
      endif
      endif
      write (111,'(A35)') "fitting for the xsec coefficient"
      if(ang.eq.1) then
      write (111,'(A43)') "second observable in bin is chi in dijet" 
      elseif(ang.eq.2) then
      write (111,'(A43)') "second observable in bin is  ys in dijet" 
      elseif(ang.eq.3) then
      write (111,'(A44)') "second observable in bin is ymax in dijet" 
      elseif(ang.eq.4) then
      write (111,'(A46)') "second observable in bin is |y| in inc. jet" 
      endif

      write(111, *) ">>"
      write(111, '(A18,A10,I2,A10,I2)') "kinematics input:","Jscheme=",
     - jetscheme, "Rscheme=", recscheme    
      write(111, '(A18,F4.1,A6,F4.1)') "jet cone size =", Rcone, 
     -   "Rsep=", Rsep
      write(111, '(A17,A8,F4.2,A4,F6.2,A4)') "jet acceptance", "|y|<", 
     - ycut, "pt>", ptcut, "GeV"
      write(111, '(A8,F6.2,A12,F6.2)') "ptj1>", ptadd1, "ptj2>", ptadd2
      write(111, '(A12,F6.2,A10,F4.2)') "|yboost|<", yb, "ystar<", ys
      write(111, *) ">>"
      write (111,'(A27)') "waiting for the .........."


c=========start of the loop in bininput.dat==============================


      do n1=1, 1


      write(111, *) "Coefficients in unit of pb*(5TeV)^2 or pb*(5TeV)^4"
      call flush(111) 

      do n2=1, nbin2
     
      if(ang.ne.4) then 
      write (111,'(A7,F8.2,A1,F8.2,A2,A4)') "mass=[", bin2(n2,1), ",", 
     -       bin2(n2,2), "]", "GeV"
      else
      write (111,'(A7,F8.2,A1,F8.2,A2,A4)') "pt=[", bin2(n2,1), ",", 
     -       bin2(n2,2), "]", "GeV"
      endif

      if(ang.eq.1) then
      write (111,'(3A9)') "chid","chiu","mu0/GeV"
      elseif(ang.eq.2) then
      write (111,'(3A9)') "ysd","ysu","mu0/GeV" 
      elseif(ang.eq.3) then
      write (111,'(3A9)') "ymaxd","ymaxu","mu0/GeV" 
      elseif(ang.eq.4) then
      write (111,'(3A9)') "|y|d","|y|u","mu0/GeV" 
      endif
      write (111,*) "Inteference: {b, a}(1-6)" 
      write (111,*) "Squared: {b, a}(11,22,12,33,44,34,55,66,56)" 
      write (111,*) "Squared: {b, a}(14,24,54,64)" 
      call flush(111) 

      do n3=1, nbin3
  
      nn=nn+1

c===============calculation of the cross section==========================

      call setcut(n1, n2, n3)

      call INITGRID

      write(zz, '("_app",I1.1)') nn
      apwname=trim(adjustl(adjustr(job)))//
     -        trim(adjustl(adjustr(zz)))//".sum"
      call apphead

      do i=1, 3
      fscale=0.5d0*2.0**(i-1) 
      rscale=1.d0 

      do itt=0, 1

      loop=itt

      if(mode.eq."resum") then
      RGE=0
      call mctotal(xsec, error)
      else
      call fitter(xcoe, ecoe)
      endif

c===============writing results===========================================


      write (*,'(A23,I3)') "**** results for bin: ", nn
      if(ang.ne.4) then 
      write (*,'(A7,F8.2,A1,F8.2,A2,A4)') "mass=[", masscutd, ",", 
     -       masscutu, "]", "GeV"
      else
      write (*,'(A7,F8.2,A1,F8.2,A2,A4)') "pt=[", masscutd, ",", 
     -       masscutu, "]", "GeV"
      endif
      if(ang.eq.1) then 
      write (*,'(A6,F6.2,A1,F6.2,A2)') "chi=[", chid, ",", chiu, "]"
      elseif(ang.eq.2) then 
      write (*,'(A6,F6.2,A1,F6.2,A2)') "ys=[", chid, ",", chiu, "]"
      elseif(ang.eq.3) then 
      write (*,'(A8,F6.2,A1,F6.2,A2)') "ymax=[", chid, ",", chiu, "]"
      elseif(ang.eq.4) then 
      write (*,'(A8,F6.2,A1,F6.2,A2)') "|y|=[", chid, ",", chiu, "]"
      endif
      do j=1,38
      write (*,'(I3,A6,D12.4,A4,D12.4)') j,"xcoe=", xcoe(j),"+-",ecoe(j) 
      enddo
      write (*,'(A27)') "waiting for the .........."

      write (111,'(2F6.2,F8.1)') chid, chiu, mu0
      write (111,'(12D12.4)') xcoe(1:12)
      write (111,'(18D12.4)') xcoe(13:30)
      write (111,'(8D12.4)') xcoe(31:38)

      call flush(111) 

      enddo
      enddo

      enddo
      enddo
      enddo

c===============end of loop===========================================

      ttm=time8()
      call ctime(ttm, time2)
      call system('for i in *.sum; do vi -e -s -c 
     -     "%s/0\.000E+00/0/g" -c "wq" $i; done')
      call system('mv *.sum ../fastCI/fgrid/')

      write (*,'(A24)') "end of the calculation."
      write (*,'(A7)') ">>>>>>"
      write (*,'(A11,A30)') "time from:", time1 
      write (*,'(A11,A30)') "time   to:", time2 
      write (111,'(A24)') "end of the calculation."
      write (111,'(A7)') ">>>>>>"
      write (111,'(A11,A30)') "time from:", time1 
      write (111,'(A11,A30)') "time   to:", time2 
      close(111)

      end program

c===============end of program========================================

      subroutine fitter(xcoe, ecoe)
c function for the calculation of all the xsec coefficients
      implicit none
      integer n, i, j, k, l, p, no(42)
      double precision xsec(42), error(42), xcoe(42), ecoe(42)
      double precision ee
      character*100 zz
      include "var.inc"
      
      xsec=0.d0
      xcoe=0.d0
      error=0.d0
      ecoe=0.d0
      no=0
      if(mode.eq."fitll") then
      do i=1, 2
      no(i)=1
      no(12+i)=1
      enddo
      elseif(mode.eq."fitcs") then
      do i=1, 3
      no(1+4*(i-1))=1
      no(2+4*(i-1))=1
      no(13+6*(i-1))=1
      no(14+6*(i-1))=1
      enddo
      else
      no=1
      endif

      n=1
      p=1
      ee=Nscale/5000.d0
      
      scheme="INT"

      ndiagnal=1
      ncross=0
      if(loop.eq.0) then
      nfac=1
      else
      nfac=2
      endif

      do k=1, 2

      do i=1, 2

      do l=1, 3
      gs2(l)=0.d0
      go2(l)=0.d0
      enddo

      if(i.eq.1) then
      gs2(k)=1.d0
      else
      go2(k)=1.d0
      endif
  
      do j=1, 2
      RGE=j-1
      write(*,'(A19,A16,I2)') "proceed with the", "fitting step...", p
      if((loop.eq.1).or.(RGE.eq.0)) then

      if(no(n).eq.1) then
      call mctotal(xsec(n), error(n))
      else
      open(unit=903, file=apwname, status="unknown", position="append")
      write(903, *) "JCC"
      close(903)
      endif

      endif
      n=n+1
      p=p+1
      enddo

      enddo

      enddo

      n=13

      scheme="SQ"

      ndiagnal=1
      if(loop.eq.0) then
      nfac=0
      else
      nfac=1
      endif
 
      do k=1, 2
     
      do i=1, 3
 
      do l=1, 3
      gs2(l)=0.d0
      go2(l)=0.d0
      enddo

      if(i.eq.1) then
      gs2(k)=1
      go2(k)=0
      ncross=0
      elseif(i.eq.2) then    
      gs2(k)=0
      go2(k)=1
      ncross=0
      else
      gs2(k)=1
      go2(k)=1
      ncross=1
      endif

      do j=1, 2
      RGE=j-1
      write(*,'(A19,A16,I2)') "proceed with the", "fitting step...", p
      if((loop.eq.1).or.(RGE.eq.0)) then

      if(no(n).eq.1) then
      call mctotal(xsec(n), error(n))
      else
      open(unit=903, file=apwname, status="unknown", position="append")
      write(903, *) "JCC"
      close(903)
      endif

      endif
      n=n+1
      p=p+1
      enddo

      enddo

      enddo

      n=31

      if(loop.eq.1) then

      ndiagnal=0
      ncross=1
      nfac=1
 
      do k=1, 2
     
      do i=1, 3
 
      do l=1, 3
      gs2(l)=0.d0
      go2(l)=0.d0
      enddo

      if(i.eq.1) then
      if(k.eq.1) then
      gs2(1)=1
      else
      go2(1)=1
      endif
      go2(2)=0
      elseif(i.eq.2) then    
      go2(2)=1
      else
      if(k.eq.1) then
      gs2(1)=1
      else
      go2(1)=1
      endif
      go2(2)=1
      endif

      do j=1, 2
      RGE=j-1
      write(*,'(A19,A16,I2)') "proceed with the", "fitting step...", p
      if((loop.eq.1).or.(RGE.eq.0)) then

      if(no(n).eq.1) then
      call mctotal(xsec(n), error(n))
      else
      open(unit=903, file=apwname, status="unknown", position="append")
      write(903, *) "JCC"
      close(903)
      endif

      endif
      n=n+1
      p=p+1
      enddo

      enddo

      enddo

      endif


100   do i=1, 12
      xsec(i)=xsec(i)*ee**2
      error(i)=error(i)*ee**2
      enddo

      do i=13, 42
      xsec(i)=xsec(i)*ee**4
      error(i)=error(i)*ee**4
      enddo

      do j=1, 8
      xcoe(j)=xsec(j)
      ecoe(j)=error(j)
      enddo

      do j=9, 12
      xcoe(j)=xcoe(j-8)
      ecoe(j)=ecoe(j-8)
      enddo

      do k=1, 2
      do j=1, 4
      xcoe(12+j+6*(k-1))=xsec(12+j+6*(k-1))
      ecoe(12+j+6*(k-1))=error(12+j+6*(k-1))
      enddo
      xcoe(12+5+6*(k-1))=xsec(12+5+6*(k-1))
      ecoe(12+5+6*(k-1))=error(12+5+6*(k-1))
      xcoe(12+6+6*(k-1))=xsec(12+6+6*(k-1))-xsec(12+2+6*(k-1))-xsec(12+4+6*(k-1))
      ecoe(12+6+6*(k-1))=dsqrt(error(12+6+6*(k-1))**2+error(12+2+6*(k-1))**2
     -    +error(12+4+6*(k-1))**2)
      enddo

      do j=25, 30
      xcoe(j)=xcoe(j-12)
      ecoe(j)=ecoe(j-12)
      enddo

      if(loop.eq.1) then
      do i=0, 1
      do k=1, 2
      xcoe(30+k+2*i)=xsec(30+k+4+6*i)-xsec(30+k+2+6*i)-xsec(30+k+6*i)
      ecoe(30+k+2*i)=dsqrt(error(30+k+4+6*i)**2+error(30+k+2+6*i)**2+error(30+k+6*i)**2)
      enddo
      enddo
      do j=35, 38
      xcoe(j)=xcoe(j-4)
      ecoe(j)=ecoe(j-4)
      enddo

      endif

      if(mode.ne."fital") then
      do i=1, 3
      xcoe(17+6*(i-1))=0.d0
      xcoe(18+6*(i-1))=0.d0
      ecoe(17+6*(i-1))=0.d0
      ecoe(18+6*(i-1))=0.d0
      enddo
      do i=31, 38
      xcoe(i)=0.d0
      ecoe(i)=0.d0
      enddo
      endif

      end subroutine
