      subroutine intdipk(k,n,p,x,results)
      implicit none
c integrated dipole subtraction term K_m+a+b, g u -> ...
c j=1(splitting from a), j=2(splitting from b), n=0(delta(1-x)),
c  n=1(regular), n=2(plus(1/(1-x))), n=3, n=4      
      double precision s, t, u, x, psplit, lgfot, CF, kbar,results(3, 2)
      double precision p(0:3, 4),gdot,colorsq(3, 2, 0:3),pplus,gaq,ktilde
      double precision aux(3, 2, 0:1)
      integer i,j,l,n,k
      parameter (CF=4.d0/3.d0)
      external psplit, gdot, pplus, kbar, ktilde
      include "var.inc"

      do i=0, 3
      call dipoleCI22(p, aux, i)
      do j=1, 3
      do l=1, 2
      colorsq(j, l, i)=aux(j, l, 0)
      enddo
      enddo
      enddo

      results=0.d0

      s=2.d0*gdot(p(0, 1), p(0, 2))
      t=-2.d0*gdot(p(0, 1), p(0, 3))
      u=-2.d0*gdot(p(0, 1), p(0, 4))
      lgfot=dlog(-facscale**2/t)
      gaq=3.d0*CF/2.d0

      do i=1, 2
      do j=1, 2
      results(i, j)=results(i, j)+kbar(1, 1, n, x)*colorsq(i, j, 0)
     -       -ktilde(1, 1, n, x)*colorsq(i, j, 1)/CF
      if((n.eq.0).or.(n.eq.2)) then
      results(i, j)=results(i, j)+gaq*(colorsq(i, j, 2)+colorsq(i, j, 3))/CF
      endif
      enddo
      enddo

      if(k.eq.2) then
      
      do i=1, 2
      results(3, 1)=results(3, 1)+(kbar(0, 1, n, x)*colorsq(i, 1, 0)
     -       -ktilde(0, 1, n, x)*colorsq(i, 1, 1)/CF)*(nf-1.d0)
      enddo

      do i=1, 2
      results(3, 1)=results(3, 1)+kbar(0, 1, n, x)*colorsq(i, 2, 0)
     -       -ktilde(0, 1, n, x)*colorsq(i, 2, 1)/CF
      enddo

      endif

      results=alfas/2.d0/pi*results*pplus(n, x)

      end subroutine

