!=======initializing the color factors, coulings and form factors used============
!================================================================================= 
      subroutine calcSUNF()
c color factors and couplings
      implicit none
      double precision CF, N, aux(0:6), pp(0:6), nloe(0:6)
      integer i, j
      parameter (CF=4.d0/3.d0)
      parameter (N=3.d0)
      include "calc.h"

      gg=0

      aux=0.d0
      coupl=0.d0

      nloe(0)=0.d0
      nloe(1)=alfas/2.d0/pi*kappao(1)*(-3.d0*CF/N)
      nloe(2)=alfas/2.d0/pi*(kappao(1)*(20.d0/3.d0/N-(2.d0*nf/3.d0))
     -   +kappas(1)*(-22.d0/3.d0)-kappao(2)*(2.d0*nf/3.d0)/2.d0)
      nloe(3)=alfas/2.d0/pi*kappao(2)*(3.d0*CF/N)
      nloe(4)=alfas/2.d0/pi*(-4.d0*kappas(1)/3.d0+(2.d0/3.d0/N-(2.d0*nf/3.d0))*kappao(1)
     -   +6.d0*kappas(2)+(6.d0*CF-3.d0/N-(2.d0*nf/3.d0))*kappao(2)-4.d0*kappas(3)/3.d0
     -   +(2.d0/3.d0/N-(2.d0*nf/3.d0))*kappao(3))
      nloe(5)=alfas/2.d0/pi*kappao(3)*(-3.d0*CF/N)
      nloe(6)=alfas/2.d0/pi*(kappao(3)*(20.d0/3.d0/N-(2.d0*nf/3.d0))
     -   +kappas(3)*(-22.d0/3.d0)-kappao(2)*(2.d0*nf/3.d0)/2.d0)

      if(mode.eq.'resum') then

      aux(0)=4.d0*pi*alfas
      call mykappa(aux(1))
      pp(0)=4.d0*pi*alfas

      do i=1, 3
      pp(2*i-1)=kappas(i)
      pp(2*i)=kappao(i)
      enddo


      do i=0, 6
      do j=0, 6
      coupl(i, j)=aux(i)*aux(j)-pp(i)*pp(j)
     -     -(pp(i)*nloe(j)+pp(j)*nloe(i))*dlog(Nscale/renscale)
      enddo
      enddo


      elseif(RGE.eq.0) then

      aux(0)=4.d0*pi*alfas

      do i=1, 3
      aux(2*i-1)=kappas(i)
      aux(2*i)=kappao(i)
      enddo

      do i=0, 6
      do j=0, 6
      coupl(i, j)=aux(i)*aux(j)
      enddo
      enddo

      if(ncross.eq.1) then
      do i=1, 6
      coupl(i, i)=0.d0
      enddo
      endif

      elseif(RGE.eq.1) then
 
      aux(0)=4.d0*pi*alfas

      do i=1, 3
      aux(2*i-1)=kappas(i)
      aux(2*i)=kappao(i)
      enddo

      do i=0, 6
      do j=0, 6
      coupl(i ,j)=aux(i)*nloe(j)+aux(j)*nloe(i)
      enddo
      enddo


      else
           print *, "wrong mode!"
           stop
      endif

      coupl(0, 0)=0.d0

      if(scheme.eq.'SQ') then

      do i=0, 0
      do j=1, 6
      coupl(i, j)=0.d0
      coupl(j, i)=0.d0
      enddo
      enddo

      elseif(scheme.eq.'INT') then

      do i=1, 6
      do j=1, 6
      coupl(i, j)=0.d0
      enddo
      enddo

      endif


      colvirt=0.d0
      colcor1=0.d0
      colcor2=0.d0
      colcor3=0.d0
      colreal=0.d0

      colvirt(1, 1)=N**2
      colvirt(3, 3)=colvirt(1, 1)

      colvirt(2, 2)=N*CF/2.d0
      colvirt(4, 4)=colvirt(2, 2)

      colvirt(1, 3)=N
      colvirt(3, 1)=colvirt(1, 3)

      colvirt(2, 4)=-CF/2.d0
      colvirt(4, 2)=colvirt(2, 4)

      colvirt(1, 4)=N*CF
      colvirt(4, 1)=colvirt(1, 4)
      colvirt(2, 3)=colvirt(1, 4)
      colvirt(3, 2)=colvirt(1, 4)

      colcor1(1, 1)=0.d0
      colcor1(1, 2)=(1.d0-1.d0/N**2)/4.d0
      colcor1(2, 1)=1.d0
      colcor1(2, 2)=-1.d0/N

      colcor1(3, 3)=0.d0
      colcor1(3, 4)=(1.d0-1.d0/N**2)/4.d0
      colcor1(4, 3)=1.d0
      colcor1(4, 4)=-1.d0/N

      colcor2(1, 1)=-CF
      colcor2(1, 2)=0.d0
      colcor2(2, 1)=0.d0
      colcor2(2, 2)=1.d0/2.d0/N

      colcor2(3, 3)=0.d0
      colcor2(3, 4)=-(1.d0-1.d0/N**2)/4.d0
      colcor2(4, 3)=-1.d0
      colcor2(4, 4)=1.d0/2.d0/N-CF

      colcor3(1, 1)=0.d0
      colcor3(1, 2)=-(1.d0-1.d0/N**2)/4.d0
      colcor3(2, 1)=-1.d0
      colcor3(2, 2)=1.d0/2.d0/N-CF

      colcor3(3, 3)=-CF
      colcor3(3, 4)=0.d0
      colcor3(4, 3)=0.d0
      colcor3(4, 4)=1.d0/2.d0/N

      colreal(1, 1)=N**2*CF
      colreal(2, 2)=colreal(1, 1)
      colreal(3, 3)=colreal(1, 1)
      colreal(4, 4)=colreal(1, 1)

      colreal(1, 3)=N*CF
      colreal(3, 1)=colreal(1, 3)
      colreal(1, 4)=colreal(1, 3)
      colreal(4, 1)=colreal(1, 3)
      colreal(2, 3)=colreal(1, 3)
      colreal(3, 2)=colreal(1, 3)
      colreal(2, 4)=colreal(1, 3)
      colreal(4, 2)=colreal(1, 3)

      if(recalc.eq.1) then
      do i=0, 6
      do j=0, 6
      if(coupl(i, j).eq.0.d0) then
      zeronot1(i, j)=0
      else
      zeronot1(i, j)=1
      endif
      enddo
      enddo
      do i=1, 6
      do j=1, 6
      if(i.eq.j) then
      zeronot2(i, j)=1
      else
      zeronot2(i, j)=0
      endif
      enddo
      enddo
      zeronot2(1, 4)=1
      zeronot2(4, 1)=1
      zeronot2(3, 6)=1
      zeronot2(6, 3)=1
      recalc=0
      endif

      end subroutine

      subroutine calcForF(s, u)
c  form factors
      implicit none
      double precision s, u, t
      integer i, j
      include "calc.h"

      t=-u-s

      qqform=0.d0
      qqxform=0.d0

      qqform(1, 1)=4.d0*s**2
      qqform(4, 4)=qqform(1, 1)
      qqform(2, 2)=8.d0*u**2
      qqform(3, 3)=4.d0*s**2
      qqform(6, 6)=qqform(3, 3)
      qqform(5, 5)=8.d0*t**2

      qqform(1, 4)=-4.d0*s**2
      qqform(4, 1)=qqform(1, 4)
      qqform(3, 6)=-4.d0*s**2
      qqform(6, 3)=qqform(3, 6)

      qqxform(1, 1)=4.d0*u**2
      qqxform(4, 4)=qqxform(1, 1)
      qqxform(2, 2)=8.d0*s**2
      qqxform(3, 3)=4.d0*u**2
      qqxform(6, 6)=qqxform(3, 3)
      qqxform(5, 5)=8.d0*t**2

      qqxform(1, 4)=-4.d0*u**2
      qqxform(4, 1)=qqxform(1, 4)
      qqxform(3, 6)=-4.d0*u**2
      qqxform(6, 3)=qqxform(3, 6)

      end subroutine
